#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>


/*==========================================================================
  TPRO_getSatInfo
==========================================================================*/

unsigned char TPRO_getSatInfo (TPRO_BoardObj *hnd, TPRO_SatObj *Satp)
{
  unsigned long length;
  int err;

  SatObj SatelliteInfo;


  // make sure we have valid handle
  if (hnd == NULL) {
    return (TPRO_HANDLE_ERR);
  }

  // make sure we are a tsat
  if ((hnd->options != 0x9070) && (hnd->options != 0x9072) &&  // 16 bit board
      (hnd->options != 0x9170) && (hnd->options != 0x9172) &&  // 32 bit board
      (hnd->options != 0x7100) && (hnd->options != 0x7300))    // cPCI, PMC
  {
    return (TPRO_INVALID_BOARD_TYPE_ERR);
  }

  /**
  ***  create I/O control returns nonzero on success
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_GET_SAT_INFO, &SatelliteInfo);
  if (err < 0)	return (TPRO_COMM_ERR);


  /**
  ***  fill-in users context
  **/

  Satp->satsTracked = SatelliteInfo.satsTracked;

  return (TPRO_SUCCESS);
}
