#include <stdio.h>
#include <ddtpro.h>
#include <tpro.h>


/*==========================================================================
  TPRO_setMatchTime
==========================================================================*/

unsigned char TPRO_setMatchTime (TPRO_BoardObj *hnd, TPRO_MatchObj *Matchp)
{
  unsigned long length;
  int err;

  MatchObj Matchtime;


  // make sure we have valid handle
  if (hnd == NULL) {
    return (TPRO_HANDLE_ERR);
  }

  /**
  ***  verify valid time
  **/

  if (Matchp->days    >  366) return (TPRO_DAY_PARM_ERR);
  if (Matchp->hours   >  23) return (TPRO_HOUR_PARM_ERR);
  if (Matchp->minutes >  59) return (TPRO_MIN_PARM_ERR);
  if ( (Matchp->seconds < 0) || (Matchp->seconds >= 60.0) ) return (TPRO_SEC_PARM_ERR);


  /**
  ***  fill-in working context
  **/
  {
    char string[10];
    double temp;

    Matchtime.matchType = Matchp->matchType;
    Matchtime.days      = Matchp->days;
    Matchtime.hours     = Matchp->hours;
    Matchtime.minutes   = Matchp->minutes;

    sprintf (string, "%2.6lf", Matchp->seconds); 	// read correct precision
    sscanf (string, "%lf", &temp);			// copy into temp variable
    temp = (temp * 1000000) + 0.5;			// multiply for bit banging
    Matchtime.seconds = (unsigned int) (temp);
  }


  /**
  ***  create I/O control
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_SET_MATCHTIME, &Matchtime);
  err = (err < 0) ? TPRO_COMM_ERR : TPRO_SUCCESS;

  return (err);
}
