#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>

/*==========================================================================
  TPRO_waitMatch
==========================================================================*/

unsigned char TPRO_waitEvent(TPRO_BoardObj *hnd, TPRO_WaitObj *waitp)
{
  WaitObj tproWait = {0};
  unsigned long length;
  int err;


  // make sure we have valid handle
  if (hnd == NULL) {
    return (TPRO_HANDLE_ERR);
  }


  /**
  ***  capture timeout value
  **/

  tproWait.jiffies = waitp->jiffies;


  /**
  ***  create I/O control
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_WAIT_EVENT, &tproWait);
  if (err < 0) err = TPRO_COMM_ERR;
  if (err > 0) err = TPRO_TIMEOUT_ERR;


  /**
  ***  copy into users context
  **/
  {
    double temp = (double) tproWait.seconds;
    temp /= (double) 1000000.0;
    waitp->seconds = temp;

    waitp->days = tproWait.days;
    waitp->hours = tproWait.hours;
    waitp->minutes = tproWait.minutes;
  }  

  return (err);
}


